/********************************************************
s-rcon-win32	half-life remote console utility
Copyright (C) 2000  M. Sean Finney <seanius@yahoo.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

********************************************************/
#include "uglyUDPstuff.h"

static int g_connected=0;
static SOCKET g_sock=0;


void oops(char *msg){
    perror(msg);
}

int make_connection(char* hostname, char*port){
	struct sockaddr_in server; 
	struct hostent *hp;
	unsigned int addr; 
	SOCKET conn_socket;
	int socket_type = SOCK_DGRAM; 
	WSADATA wsaData;
	
	if(WSAStartup(0x202,&wsaData)==SOCKET_ERROR){
		oops("WSAStartup failed. Windows sucks"); return -1;} 
	if(isalpha(hostname[0])) { hp = gethostbyname(hostname); } 
	else  { addr = inet_addr(hostname); hp = gethostbyaddr((char*)&addr,4,AF_INET); } 
	if(hp==NULL){oops("Cannot resolve address"); return -1;}  

	memset(&server,0,sizeof(server)); 
	memcpy(&(server.sin_addr),hp->h_addr,hp->h_length); 
	server.sin_family = hp->h_addrtype; 
	server.sin_port = htons(atoi(port));  
	conn_socket = socket(AF_INET,socket_type,0);

	if (conn_socket<0){oops("Error Opening socket.  Windows sucks."); return -1; }  
	if (connect(conn_socket,(struct sockaddr*)&server,sizeof(server))==SOCKET_ERROR){
		oops("connect() failed.  Check your net homie.");  return -1; }  

	g_sock=conn_socket;
	g_connected=1;
	return conn_socket;
}
	
void send_command(char* formatted_command){
if(!g_connected) oops("error: not connected\n");
printf("going to send:\n%s\n", formatted_command);
send(g_sock, formatted_command, strlen(formatted_command), 0);
}
